//
// Created by William on 23/10/2024.
//

#ifndef BIOINFORMATIKPROJEKT_BRUTEFORCE_H
#define BIOINFORMATIKPROJEKT_BRUTEFORCE_H
#include "../cache/LongTermCacheData.h"
#include "../../model/HPModel.h"
class Executor {
public:
    Executor(const std::string& sequence);
    void execute();
    LongTermCacheData data;
private:
    int expectedFoldLength;
    const std::string& sequence;
    void logProgress();
    std::vector<std::string> possibleFolds;
    std::map<std::string, HPModel> cache;
    std::map<int, std::vector<std::string>> impossibleFoldCache;
    void addImpossibleFold(std::string fold);
    void updateModel(HPModel newModel, std::string subFold);
};

std::tuple<int, std::string> findOptimalScore(const std::string& sequence);
void executeToDos();

#endif //BIOINFORMATIKPROJEKT_BRUTEFORCE_H
